VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Form1"
   ClientHeight    =   4410
   ClientLeft      =   90
   ClientTop       =   375
   ClientWidth     =   5100
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4410
   ScaleWidth      =   5100
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command6 
      Caption         =   "Benchmark"
      Height          =   435
      Left            =   60
      TabIndex        =   6
      Top             =   3840
      Width           =   1575
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Benchmark"
      Height          =   435
      Left            =   1740
      TabIndex        =   5
      Top             =   3840
      Width           =   1575
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Benchmark"
      Height          =   435
      Left            =   3360
      TabIndex        =   4
      Top             =   3840
      Width           =   1575
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Manipulate semi-1D"
      Height          =   435
      Left            =   3360
      TabIndex        =   3
      Top             =   3360
      Width           =   1575
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Manipulate 1D"
      Height          =   435
      Left            =   1740
      TabIndex        =   2
      Top             =   3360
      Width           =   1575
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Manipulate 2D"
      Height          =   435
      Left            =   60
      TabIndex        =   1
      Top             =   3360
      Width           =   1575
   End
   Begin VB.PictureBox Picture1 
      Height          =   1875
      Left            =   120
      ScaleHeight     =   121
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   135
      TabIndex        =   0
      Top             =   120
      Width           =   2085
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Private Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Private Type SAFEARRAY
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Private IMAGEWIDTH As Long
Private IMAGEHEIGHT As Long

Private ImageBuffer() As Byte

Private Sub Command1_Click()

Manipulate2D

End Sub

Private Sub Command2_Click()

Manipulate1D

End Sub

Private Sub Command3_Click()

ManipulateSemi1D

End Sub

Private Sub Command4_Click()

Dim StartTime As Date
Dim FPS As Long

Me.MousePointer = vbHourglass

StartTime = Now

Do Until Now <> StartTime: DoEvents: Loop

StartTime = Now

Do Until Now <> StartTime
    ManipulateSemi1D
    FPS = FPS + 1
Loop

Me.MousePointer = vbDefault

MsgBox "Your system runs " & FPS & " frames per second.", vbInformation

End Sub

Private Sub Command5_Click()

Dim StartTime As Date
Dim FPS As Long

Me.MousePointer = vbHourglass

StartTime = Now

Do Until Now <> StartTime: DoEvents: Loop

StartTime = Now

Do Until Now <> StartTime
    Manipulate1D
    FPS = FPS + 1
Loop

Me.MousePointer = vbDefault

MsgBox "Your system runs " & FPS & " frames per second.", vbInformation

End Sub

Private Sub Command6_Click()

Dim StartTime As Date
Dim FPS As Long

Me.MousePointer = vbHourglass

StartTime = Now

Do Until Now <> StartTime: DoEvents: Loop

StartTime = Now

Do Until Now <> StartTime
    Manipulate2D
    FPS = FPS + 1
Loop

Me.MousePointer = vbDefault

MsgBox "Your system runs " & FPS & " frames per second.", vbInformation

End Sub

Private Sub Form_Load()

Dim Bmp As BITMAP

Form1.Picture1.Picture = LoadPicture(App.Path & "\Doom.bmp")

Call GetObject(Form1.Picture1.Picture, Len(Bmp), Bmp)

IMAGEWIDTH = Bmp.bmWidth
IMAGEHEIGHT = Bmp.bmHeight

Form1.Picture1.Appearance = 0
Form1.Picture1.BorderStyle = vbBSNone
Form1.Picture1.Width = IMAGEWIDTH * Screen.TwipsPerPixelX
Form1.Picture1.Height = IMAGEHEIGHT * Screen.TwipsPerPixelY
Form1.Picture1.ScaleMode = vbPixels

End Sub

Private Sub Manipulate2D()

Dim xPix As Long
Dim yPix As Long
Dim Bmp As BITMAP
Dim SA As SAFEARRAY

Call GetObject(Form1.Picture1.Picture, Len(Bmp), Bmp)

With SA
  .cbElements = 1
  .cDims = 2
  .Bounds(0).lLbound = 0
  .Bounds(0).cElements = Bmp.bmHeight
  .Bounds(1).lLbound = 0
  .Bounds(1).cElements = Bmp.bmWidthBytes
  .pvData = Bmp.bmBits
End With

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), VarPtr(SA), 4)

For xPix = 0 To UBound(ImageBuffer, 1) Step 3
    For yPix = 0 To UBound(ImageBuffer, 2)
        ImageBuffer(xPix, yPix) = 255       'Blau
        ImageBuffer(xPix + 1, yPix) = 0     'Grn
        ImageBuffer(xPix + 2, yPix) = 0     'Rot
    Next
Next

For xPix = 0 To 100 Step 3
    ImageBuffer(xPix, IMAGEHEIGHT - 10) = 0       'Blau
    ImageBuffer(xPix + 1, IMAGEHEIGHT - 10) = 0   'Grn
    ImageBuffer(xPix + 2, IMAGEHEIGHT - 10) = 0   'Rot
Next

Form1.Picture1.Refresh

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), 0&, 4) 'Hiernach ist das Array "gelscht"! Falls es danach noch genutzt werden soll, muss es neu instanziiert werden.

ReDim ImageBuffer(0 To 0) As Byte

End Sub

Private Sub Manipulate1D()

Dim xPix As Long
Dim yPix As Long
Dim Offset As Long
Dim Bmp As BITMAP
Dim SA As SAFEARRAY

Call GetObject(Form1.Picture1.Picture, Len(Bmp), Bmp)

With SA
  .cbElements = 1
  .cDims = 1
  .Bounds(0).lLbound = 0
  .Bounds(0).cElements = Bmp.bmWidthBytes * Bmp.bmHeight
  .pvData = Bmp.bmBits
End With

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), VarPtr(SA), 4)

For Offset = 0 To UBound(ImageBuffer) Step 3
    ImageBuffer(Offset) = 0         'Blau
    ImageBuffer(Offset + 1) = 0     'Grn
    ImageBuffer(Offset + 2) = 255   'Rot
Next

For xPix = 0 To 100 \ 3
    Offset = (IMAGEHEIGHT - 10) * IMAGEWIDTH * 3 + (xPix * 3)
    ImageBuffer(Offset) = 0         'Blau
    ImageBuffer(Offset + 1) = 0     'Grn
    ImageBuffer(Offset + 2) = 0     'Rot
Next

Form1.Picture1.Refresh

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), 0&, 4) 'Hiernach ist das Array "gelscht"! Falls es danach noch genutzt werden soll, muss es neu instanziiert werden.

ReDim ImageBuffer(0 To 0) As Byte

End Sub

Private Sub ManipulateSemi1D()

Dim xPix As Long
Dim yPix As Long
Dim Offset As Long
Dim Bmp As BITMAP
Dim SA As SAFEARRAY

Call GetObject(Form1.Picture1.Picture, Len(Bmp), Bmp)

With SA
  .cbElements = 1
  .cDims = 1
  .Bounds(0).lLbound = 0
  .Bounds(0).cElements = Bmp.bmWidthBytes * Bmp.bmHeight
  .pvData = Bmp.bmBits
End With

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), VarPtr(SA), 4)

For xPix = 0 To (IMAGEWIDTH - 1)
    For yPix = 0 To (IMAGEHEIGHT - 1)
        Offset = yPix * IMAGEWIDTH * 3 + (xPix * 3)
        ImageBuffer(Offset) = 0         'Blau
        ImageBuffer(Offset + 1) = 255   'Grn
        ImageBuffer(Offset + 2) = 0     'Rot
    Next
Next

For xPix = 0 To 100 \ 3
    Offset = (IMAGEHEIGHT - 10) * IMAGEWIDTH * 3 + (xPix * 3)
    ImageBuffer(Offset) = 0         'Blau
    ImageBuffer(Offset + 1) = 0     'Grn
    ImageBuffer(Offset + 2) = 0     'Rot
Next

Form1.Picture1.Refresh

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), 0&, 4) 'Hiernach ist das Array "gelscht"! Falls es danach noch genutzt werden soll, muss es neu instanziiert werden.

ReDim ImageBuffer(0 To 0) As Byte

End Sub
